<script setup>
import { CdxField, CdxLabel, CdxTextArea, CdxMultiselectLookup, CdxTextInput } from '@wikimedia/codex';
import { useInstrumentStore } from '../../stores/instrument.js';
import { ref } from 'vue';

const instrumentStore = useInstrumentStore();

const ownerChips = ref( instrumentStore.instrument.owner.map( item => ({ label: item, value: item})) );
const ownerSelection = ref( instrumentStore.instrument.owner );
const ownerMenuItems = ref( [] );
const ownerItems = [
    { label: 'Abstract Team', value: 'Abstract Team' },
    { label: 'Android Team', value: 'Android Team' },
    { label: 'Growth Team', value: 'Growth Team' },
    { label: 'Language Team', value: 'Language Team' },
    { label: 'Trust & Safety Team', value: 'Trust & Safety Team' },
    { label: 'Web Team', value: 'Web Team' }
];

function onOwnerInput( value ) {
    if ( value ) {
        ownerMenuItems.value = ownerItems.filter(( item ) =>
            item.label.toLowerCase().includes( value.toLowerCase() )
        );
    } else {
        ownerMenuItems.value = [];
    }
}

function onOwnerChanged( newSet ) {
    instrumentStore.instrument.owner = newSet;
}

const purposeChips = ref( instrumentStore.instrument.purpose.map( item => ({ label: item, value: item})) );
const purposeSelection = ref( instrumentStore.instrument.purpose );
const purposeMenuItems = ref( [] );
const purposeItems = [
    { label: 'FY24/25 WE.1.1', value: 'FY24/25 WE.1.1' },
    { label: 'FY24/25 WE.1.2', value: 'FY24/25 WE.1.2' },
    { label: 'FY24/25 WE.1.3', value: 'FY24/25 WE.1.3' },
    { label: 'FY24/25 WE.2.1/KE 1', value: 'FY24/25 WE.2.1/KE 1' },
    { label: 'FY24/25 WE.2.2/KE 2', value: 'FY24/25 WE.2.2/KE 2' },
    { label: 'FY24/25 WE.2.3/KE 3', value: 'FY24/25 WE.2.3/KE 3' },
    { label: 'FY24/25 WE.2.4/KE 4', value: 'FY24/25 WE.2.4/KE 4' },
    { label: 'FY24/25 WE.3.1', value: 'FY24/25 WE.3.1' },
    { label: 'FY24/25 WE.3.2', value: 'FY24/25 WE.3.2' },
    { label: 'FY24/25 WE.4.1', value: 'FY24/25 WE.4.1' },
    { label: 'FY24/25 WE.4.2', value: 'FY24/25 WE.4.2' },
    { label: 'FY24/25 WE.4.3', value: 'FY24/25 WE.4.3' },
    { label: 'FY24/25 WE.4.4', value: 'FY24/25 WE.4.4' },
    { label: 'FY24/25 WE.5.1', value: 'FY24/25 WE.5.1' },
    { label: 'FY24/25 WE.5.2', value: 'FY24/25 WE.5.2' },
    { label: 'FY24/25 WE.5.3', value: 'FY24/25 WE.5.3' },
    { label: 'FY24/25 WE.5.4', value: 'FY24/25 WE.5.4' },
    { label: 'FY24/25 WE.6.1', value: 'FY24/25 WE.6.1' },
    { label: 'FY24/25 WE.6.2', value: 'FY24/25 WE.6.2' },
    { label: 'FY24/25 WE.6.3', value: 'FY24/25 WE.6.3' },
    { label: 'FY24/25 SDS.1.1', value: 'FY24/25 SDS.1.1' },
    { label: 'FY24/25 SDS.1.2', value: 'FY24/25 SDS.1.2' },
    { label: 'FY24/25 SDS.1.3', value: 'FY24/25 SDS.1.3' },
    { label: 'FY24/25 SDS.2.1', value: 'FY24/25 SDS.2.1' },
    { label: 'FY24/25 SDS.2.2', value: 'FY24/25 SDS.2.2' },
    { label: 'FY24/25 SDS.2.3', value: 'FY24/25 SDS.2.3' },
    { label: 'FY24/25 FA.1.1', value: 'FY24/25 FA.1.1' },
    { label: 'FY24/25 PES.1.1', value: 'FY24/25 PES.1.1' },
    { label: 'FY24/25 PES.1.2', value: 'FY24/25 PES.1.2' },
    { label: 'FY24/25 PES.1.3', value: 'FY24/25 PES.1.3' },
    { label: 'FY24/25 PES.1.4', value: 'FY24/25 PES.1.4' },
];

function onPurposeInput( value ) {
    if ( value ) {
        purposeMenuItems.value = purposeItems.filter(( item ) => 
            item.label.toLowerCase().includes( value.toLowerCase() )
        );
    } else {
        purposeMenuItems.value = [];
    }
}

function onPurposeChanged ( newSet ) {
    instrumentStore.instrument.purpose = newSet;
}
</script>

<template>
    <h2>Details</h2>

    <!-- DETAILS: Description -->
    <cdx-field>
        <cdx-text-area
            v-model="instrumentStore.instrument.description"
            data-id="description"
            placeholder="Write an optional description or hypothesis"
        />
        <template #label>
            <cdx-label optional-flag="(optional)">Description</cdx-label>
        </template>
        <template #description>
            <span v-if="instrumentStore.isABTest">
                Provide this experiment's hypothesis and a brief summary of other key details for future reference
            </span>
            <span v-else>
                Provide a brief summary of this instrument’s purpose and key details for future reference
            </span>
        </template>
    </cdx-field>

    <!-- DETAILS: Purpose -->
    <cdx-field>
        <cdx-multiselect-lookup
            v-model:input-chips="purposeChips"
            v-model:selected="purposeSelection"
            :menu-items="purposeMenuItems"
            default-label="Select a purpose..."
            data-id="purpose"
            @input="onPurposeInput"
            @update:selected="onPurposeChanged($event)"
            placeholder="Select the related initiatives"
        />
        <template #label>
            <cdx-label optional-flag="(optional)">Related OKRs</cdx-label>
        </template>
        <template #description>
            Select the initiatives that this {{instrumentStore.instrument.type}} supports
        </template>
    </cdx-field>

    <!-- DETAILS: Phab Task -->
    <cdx-field>
        <cdx-text-input
            v-model="instrumentStore.instrument.task"
            size=20
            data-id="task"
            placeholder="E.g., https://phabricator.wikimedia.org/T366325"
        />
        <template #label>
            Phabricator Task
        </template>
        <template #description>
            Add a link to the associated epic task in Phabricator.
        </template>
    </cdx-field>

    <!-- DETAILS: Team -->
    <cdx-field>
        <cdx-multiselect-lookup
            v-model:input-chips="ownerChips"
            v-model:selected="ownerSelection"
            :menu-items="ownerMenuItems"
            default-label="Select a team..."
            data-id="owner"
            @input="onOwnerInput"
            @update:selected="onOwnerChanged($event)"
            placeholder="Select teams"
        />
        <template #label>
            <cdx-label optional-flag="(optional)">Teams</cdx-label>
        </template>
        <template #description>
            Select the team that owns the {{ instrumentStore.instrument.type }}
        </template>
    </cdx-field>

    <!-- DETAILS: Contact Email -->
    <cdx-field>
        <cdx-text-input size=20
            v-model="instrumentStore.instrument.email_address"
            data-id="email"
            placeholder="e.g. bwaine@wikimedia.org"
        />
        <template #label>
            Contact Email
        </template>
        <template #description>
            Provide an email address to contact about this {{ instrumentStore.instrument.type }}.
        </template>
    </cdx-field>
</template>

<style scoped>
.column.right {
    margin-top: 20px;
}
.cdx-label__description, .cdx-label__label {
    color: var( --color-base);
}
</style>
